# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from openapi_server.models.base_model_ import Model
from openapi_server import util


class Item(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, uid=None, task=None, is_done=None):  # noqa: E501
        """Item - a model defined in OpenAPI

        :param uid: The uid of this Item.  # noqa: E501
        :type uid: str
        :param task: The task of this Item.  # noqa: E501
        :type task: str
        :param is_done: The is_done of this Item.  # noqa: E501
        :type is_done: bool
        """
        self.openapi_types = {
            'uid': str,
            'task': str,
            'is_done': bool
        }

        self.attribute_map = {
            'uid': 'uid',
            'task': 'task',
            'is_done': 'isDone'
        }

        self._uid = uid
        self._task = task
        self._is_done = is_done

    @classmethod
    def from_dict(cls, dikt) -> 'Item':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Item of this Item.  # noqa: E501
        :rtype: Item
        """
        return util.deserialize_model(dikt, cls)

    @property
    def uid(self):
        """Gets the uid of this Item.


        :return: The uid of this Item.
        :rtype: str
        """
        return self._uid

    @uid.setter
    def uid(self, uid):
        """Sets the uid of this Item.


        :param uid: The uid of this Item.
        :type uid: str
        """

        self._uid = uid

    @property
    def task(self):
        """Gets the task of this Item.


        :return: The task of this Item.
        :rtype: str
        """
        return self._task

    @task.setter
    def task(self, task):
        """Sets the task of this Item.


        :param task: The task of this Item.
        :type task: str
        """

        self._task = task

    @property
    def is_done(self):
        """Gets the is_done of this Item.


        :return: The is_done of this Item.
        :rtype: bool
        """
        return self._is_done

    @is_done.setter
    def is_done(self, is_done):
        """Sets the is_done of this Item.


        :param is_done: The is_done of this Item.
        :type is_done: bool
        """

        self._is_done = is_done
